/*
(c) 2010 Perttu Ahola <celeron55@gmail.com>
*/

#ifndef MAPSECTOR_HEADER
#define MAPSECTOR_HEADER

#include <jmutex.h>
#include "common_irrlicht.h"
#include "mapblock.h"
#include "referencecounted.h"
#include "heightmap.h"

/*
	This is an Y-wise stack of MapBlocks.
	
	TODO:
	Add heightmap functionality
*/

class Map;

class MapSector : public ReferenceCounted, public HeightmapSource
{
	// The pile of MapBlocks
	core::map<s16, MapBlock*> m_blocks;
	//JMutex m_blocks_mutex; // For public access functions

	// Position on map (MapBlocks)
	v2s16 m_pos;

	MapBlock *getBlockBuffered(s16 y);

	Map *m_map;

public:

	JMutex mutex;

	MapSector(v2s16 pos, Map *map):
			ReferenceCounted("MapSector")
	{
		//m_blocks_mutex.Init();
		mutex.Init();
		m_pos = pos;
		m_map = map;
	}

	// If these return !NULL, the returned block should be
	// dropped() after use
	Ref<MapBlock> getBlock(s16 y);
	Ref<MapBlock> createBlankBlock(s16 y);

	f32 getGroundHeight(v2s16 p);
	void setGroundHeight(v2s16 p, f32 h);
};

#endif

