/*
(c) 2010 Perttu Ahola <celeron55@gmail.com>
*/

#ifndef PLAYER_HEADER
#define PLAYER_HEADER

#include <irrlicht.h>

#define PLAYERNAME_SIZE 20

using namespace irr;
typedef core::vector3df v3f;
typedef core::vector3d<s16> v3s16;

class Map;

class Player : public scene::ISceneNode
{
public:
	Player(
		bool is_local,
		scene::ISceneNode* parent=NULL,
		IrrlichtDevice *device=NULL,
		s32 id=0);
	
	~Player();

	void move(f32 dtime, Map &map);

	/*
		ISceneNode methods
	*/

	virtual void OnRegisterSceneNode()
	{
		if (IsVisible)
			SceneManager->registerNodeForRendering(this);

		ISceneNode::OnRegisterSceneNode();
	}

	virtual void render()
	{
		// Do nothing
	}
	
	virtual const core::aabbox3d<f32>& getBoundingBox() const
	{
		return m_box;
	}

	/*v3f getPosition()
	{
		return m_position;
	}

	void setPosition(v3f position)
	{
		m_position = position;
		updateSceneNodePosition();
	}*/

	v3f getSpeed()
	{
		return speed;
	}

	/*void updateSceneNodePosition()
	{
		ISceneNode::setPosition(m_position);
	}*/

	void setPitch(f32 pitch)
	{
		m_pitch = pitch;
	}

	void setYaw(f32 yaw)
	{
		setRotation(v3f(0, -yaw, 0));
		m_yaw = yaw;
	}

	f32 getPitch()
	{
		return m_pitch;
	}

	f32 getYaw()
	{
		return m_yaw;
	}

	bool isLocal()
	{
		return m_is_local;
	}

	void updateName(const char *name);

	const char * getName()
	{
		return m_name;
	}

	v3f speed;
	bool touching_ground;
	u16 peer_id;
	//float timeout_counter;

private:
	char m_name[PLAYERNAME_SIZE];
	bool m_is_local;
	f32 m_pitch;
	f32 m_yaw;
	//v3f m_position;
	//scene::ISceneNode* m_bill;
	//scene::IBillboardSceneNode* m_bill; //TODO: Not used
	scene::ITextSceneNode* m_text;
	
	core::aabbox3d<f32> m_box;
};

#endif

