#ifndef CLIENTSERVER_HEADER
#define CLIENTSERVER_HEADER

#define PROTOCOL_ID 0x4f457403

enum ToClientCommand
{
	TOCLIENT_INIT=0x10,
	TOCLIENT_BLOCKDATA=0x20, //TODO: Multiple blocks
	TOCLIENT_ADDNODE,
	TOCLIENT_REMOVENODE,
	TOCLIENT_PLAYERPOS,
	TOCLIENT_PLAYERINFO,
	TOCLIENT_OPT_BLOCK_NOT_FOUND, // Not used

	TOCLIENT_SECTORMETA,
	/*
		[0] u16 command
		[2] u8 sector count
		[3...] v2s16 pos + sector metadata
	*/
};

enum ToServerCommand
{
	TOSERVER_INIT=0x10,
	TOSERVER_GETBLOCK=0x20, // Not used
	TOSERVER_ADDNODE,
	TOSERVER_REMOVENODE,
	TOSERVER_PLAYERPOS,

	TOSERVER_GOTBLOCKS,
	/*
		[0] u16 command
		[2] u8 count
		[3] v3s16 pos_0
		[3+6] v3s16 pos_1
		...
	*/

	TOSERVER_DELETEDBLOCKS,
	/*
		[0] u16 command
		[2] u8 count
		[3] v3s16 pos_0
		[3+6] v3s16 pos_1
		...
	*/
};

// Flags for TOSERVER_GETBLOCK
#define TOSERVER_GETBLOCK_FLAG_OPTIONAL (1<<0)

#endif

